﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

namespace PureChat.Plugins.OnTime
{
	public partial class AddTask : OnTimePluginControl
	{
		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);
			btnSave.Click += btnSave_Click;
			this.Page.ClientScript.RegisterStartupScript(this.GetType(), "messagePopupId", string.Format("messagePopupId = '{0}';", messagePopup.ClientID), true);
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			if (!IsPostBack)
			{
				txtTaskName.Text = GetDefaultValue(Settings.TaskDefaultValues.ContainsKey("Name") ? Settings.TaskDefaultValues["Name"] : string.Empty);
				txtNotes.Text = string.Join(Environment.NewLine, ChatObject.ChatTranscript.ToArray());
				GetUserNames(ddlUsers, GetDefaultValue(Settings.TaskDefaultValues.ContainsKey("AssignedToId") ? Settings.TaskDefaultValues["AssignedToId"] : OperatorName));
				GetProjects(ddlProjects, GetDefaultValue(Settings.TaskDefaultValues.ContainsKey("ProjectId") ? Settings.TaskDefaultValues["ProjectId"] : string.Empty));
			}
		}

		protected void btnSave_Click(object sender, EventArgs e)
		{
			OnTimeSDK.Task.Task task = new OnTimeSDK.Task.Task();
			task.AssignedToId = int.Parse(ddlUsers.SelectedValue);
			task.Name = txtTaskName.Text.Trim();
			string notes = txtNotes.Text;
			if (Settings.HtmlDetailFields)
				notes = notes.Replace(Environment.NewLine, "<br />");
			task.Notes = notes;
			task.ProjectId = ddlProjects.GetSelectedItemValue();
			int taskid = 0;
			using (OnTimeSDK.Task.TaskHandler handler = new OnTimeSDK.Task.TaskHandler(Settings.TaskServiceUrl))
			{
				taskid = handler.AddTask(Settings.SecurityGuid, task);
			}
			Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId", string.Format("afterMessageFunc = closeWindow; url = '{0}'; setTimeout('showSuccessMessage(\"Task added successfully! Task Id - {{0}}\");', 250);", GetItemIdUrl(taskid.ToString(), "task")), true);
		}
	}
}